/*
              HORLOGE MERE PILOTEE PAR GPS
              ----------------------------
  GPS  sortie TX pin D0
  Affichage sur shield LCD (2*16). 
  Modification du décalage horaire (été hiver) par touches up/down
  Avance rapide touche Rigth

  Prévue pour modules double ponts en H
  Au choix L9110, L293 ou L298 reliés à D2 et D3
  Prévoir rhéostats ou potentiomètres 500 ohms en
  série avec les bobines des réceprices (réglage fin)
  

 
  F5MNA    Site http://f5mna.free.fr
  Mars 2017
  Version 1.1  Modif impulsion.s
 */

//Concerne GPS
#include <TinyGPS.h>
TinyGPS gps;
#include <floatToString.h>
//#include <EEPROM.h>
#include <eeprom.h>

//LCD
#include <LiquidCrystal.h>
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

//Boutons
int Val, n, h, Pos, hour0, FdM;
int HLocPin = A0; // Boutons heure locale
int H_locale = 0; 
int val_key;

static void gpsdump(TinyGPS &gps);
static bool feedgps();
static void print_float(float val, float invalid, int len, int prec);
static void print_int(unsigned long val, unsigned long invalid, int len);
static void print_date(TinyGPS &gps);

////// Sorties tensions alternées + avance rapide //////
int Altern1 = 2; // pin 11 tension alternée 
int Altern2 = 3; // pin 12 tension alternée inverse

//////////////////////////////////////////////////////////////
void setup()
{
  Serial.begin (9600);
  n = 0;
  h = EEPROM.get (0,h);
// Déclaration tension alternée & Avance rapide//////////
    pinMode(Altern1, OUTPUT);
    pinMode(Altern2, OUTPUT);
//Presentation
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);

  lcd.print ("  Horloge mere  ");
  lcd.setCursor(0, 1);
  lcd.print ("F5MNA  Version 1");
  delay(2000);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("  En cours...   ");
  lcd.setCursor(0, 1);
  lcd.print(" Patientez SVP  ");
  
  Serial.println ("Recherche trames");
  Serial.println ("  Patientez     ");
}
/////////////////////////////////////////////////////////////
void GPS()
////////////////////////////////////////////////////////////
{
  bool newdata = true;
  unsigned long start = millis();
  
 // Affichage toutes les 1/2 secondes
  while (millis() - start < 500)
  {
    if (feedgps())
      newdata = true;
  }
  gpsdump(gps);
}

static void gpsdump(TinyGPS &gps)
{
  unsigned long age, date, time, chars = 0;
  unsigned short sentences = 0, failed = 0;
  print_date(gps);
}
////////////////////////
////  DATE & HEURE  ////
////////////////////////
static void print_date(TinyGPS &gps)
{
  int year;
  byte month, day, hour, minute, second, hundredths;
  unsigned long age;
  gps.crack_datetime(&year, &month, &day, &hour, &minute, &second, &hundredths, &age);
  {
    char sz[32];
    sprintf(sz, "  %02d/%02d/%02d %02d:%02d:%02d   ",
            day, month, year, hour , minute, second); /// + h décalage / UTC    
                    

         //////// TENSION ALTERNEE /////////////
                 

  if (second == 00) {digitalWrite(Altern2, LOW); delay (250);}//////////Selon résistances de tirage (au + VCC pour L9110)
  else if (second == 30)  {digitalWrite(Altern1, LOW); delay (250);} //////////Selon résistances de tirage (au + VCC pour L9110)
  else
  {digitalWrite(Altern1, HIGH);   //////////Selon résistances de tirage (au + VCC pour L9110)
  digitalWrite(Altern2, HIGH);}   //////////Selon résistances de tirage (au + VCC pour L9110) 
          
   ////////// Passage à J+1 selon décalage horaire //////////////
   ////////////// En fin de mois n passe a mois+1 ///////////////     
   
      if ((hour + h) > 23) day = day + 1;
      if ((h < 0) and (hour + h) > 0) day = day - 1; 
       
      if ((FdM == 0) and (day == 31)) {
      day = 1;
      month = (month + 1);  
      }

      if ((FdM == 1) and (day == 32)) {
      day = 1;
      month = (month + 1);
      if (month == 13)
      {month = 1;
      year = year + 1;   
      }}
      
      if ((FdM == 2) and (day == 29)) {
      day = 1;
      month = (month + 1);    
       } 
     }
  /////////////////////////////////////////////////////////////
  if (year > 2000) {
  ////////////////////////////////////////////////////////////
    if (n == 0) {
      lcd.setCursor (0, 0 );
      switch (Pos) {
        case 1:
          lcd.print(" ");
          break;

        case  2:
          lcd.print("  ");
          break;

        case 3:
          lcd.print("   ");
          break;
      }

      if (day < 10)  lcd.print(" ");
      lcd.print(day);
      switch (month) {
        case 1:
          lcd.print  (" janvier ");
          Pos = 1;                     // Position de l'affichage
          FdM = 1;                     // Jour fin de mois
          break;
        case 2:
          lcd.print  (" fevrier ");
          Pos = 1;
          FdM = 2;
          break;
        case 3:
          lcd.print (" mars ");
          Pos = 2;
          FdM = 1;
          break;
        case 4:
          lcd.print (" avril ");
          Pos = 2;
          FdM = 0;
          
          break;
        case 5:
          lcd.print (" mai ");
          Pos = 3;
          FdM = 1;
          break;
        case 6:
          lcd.print (" juin ");
          Pos = 2;
          FdM = 0;
          break;
        case 7:
          lcd.print (" juillet ");
          Pos = 1;
          FdM = 1;
          break;
        case 8:
          lcd.print (" aout ");
          Pos = 2;
          FdM = 1;
          break;
        case 9:
          lcd.print (" septemb.");
          Pos = 1;
          FdM = 0;
          break;
        case 10:
          lcd.print (" octobre ");
          Pos = 1;
          FdM = 1;
          break;
        case 11:
          lcd.print (" novembre ");
          Pos = 0;
          FdM = 0;
          break;
        case 12:
          lcd.print (" decembre ");
          Pos = 0;
          FdM = 1;
          break;
      }
       lcd.print (year);
       lcd.print (" ");
      }
      
      lcd.print ("      ");
      hour = (hour + h);
      lcd.setCursor(0, 1 );
      lcd.print("    ");
      if (hour > 23) (hour = 0);
      if (hour < 10) (lcd.print ("0"));
      lcd.print(hour);
      lcd.print(":");
      if (minute < 10) (lcd.print ("0"));
      lcd.print(minute);
      lcd.print(":");
      if (second < 10) (lcd.print ("0"));
      lcd.print(second);
      lcd.print("   ");

      Serial.print (day);
      Serial.print (":");
      Serial.print (month);
      Serial.print (":");
      Serial.println (year);

      Serial.print (hour);
      Serial.print (":");
      Serial.print (minute);
      Serial.print (":");
      Serial.println (second);
      Serial.println ("");
      Serial.println ("");
 

      //////////////////////////////////////// 
  } 
  feedgps();
}
////////////////////////////////////

static bool feedgps()
{
  while (Serial.available())
  {
    if (gps.encode(Serial.read()))
    return true;
  }
  return false;
}


void loop ()
{
      val_key = 0;                      // RAZ valeur de la touche
      H_locale = analogRead(HLocPin);   // lecture de la touche heure locale
      val_key = int(H_locale / 100);    // valeur entière de la touche / 10
      switch (val_key)
      {
        // Avance heure / UTC  (Up/Down)
        case 1 :                              //UP
          lcd.setCursor ( 0, 0 );
          lcd.print ("  H locale/UTC   ");
          lcd.setCursor ( 0, 1 );
          h = h + 1;
          if (h > 0)  lcd.print("      +");
          if (h == 0) lcd.print("       ");
          if (h < 0)  lcd.print("      ");
          lcd.print (h);
          lcd.print(" H      ");
          EEPROM.put (0,h);
          if (h > 12)  (h = 0);
          delay (500);
          break;

        case 3:                               //DOWN
          lcd.setCursor ( 0, 0 );
          lcd.print ("  H locale/UTC   ");
          lcd.setCursor ( 0, 1 );
          h = h - 1;
          if (h > 0)  lcd.print("      +");
          if (h == 0) lcd.print("       ");
          if (h < 0)  lcd.print("      ");
          lcd.print (h);
          lcd.print(" H      ");
          if (h < -12) (h = 0);
          EEPROM.put (0,h);
          delay (500);
          break;          

        case 0:
          digitalWrite (Altern1, HIGH);      // 
          digitalWrite (Altern2, LOW);
          delay(250);
          digitalWrite (Altern1, LOW);
          digitalWrite (Altern2, HIGH);
          delay(250);
          break;
               
        case 10 : 
          GPS();    
          break; 
      }       
}                                                                                                                    




